//
// Most of the code here is taken from 
// "JavaScript: The Definitive Guide" by David Flanagan
//

function isWindows() 
{
    return (navigator.appVersion.indexOf("Win") != -1);
}


function Cookie(document, name, hours, path, domain, secure)
{
	this.$document = document;
	this.$name = name;
	if (hours) 
		this.$expiration = new Date((new Date()).getTime()+hours*3600000); 
	else 
		this.$expiration = null;

	if (path) 
		this.$path = path; 
	else 
		this.$path = null;

	if (domain) 
		this.$domain = domain; 
	else 
		this.$domain = null;

	if (secure)
		this.$secure = true; 
	else 
		this.$secure = false;
}


function _Cookie_store()
{
	var cookieval = "";
	for(var prop in this)
	{
		if ((prop.charAt(0) == '$') || ((typeof this[prop]) == 'function'))
			continue;
		if (cookieval != "") cookieval += '&';
			cookieval += prop + ':' + escape(this[prop]);
    }

	var cookie = this.$name + '=' + cookieval;

	if (this.$expiration)
		cookie += '; expires=' + this.$expiration.toGMTString();
	if (this.$path) 
		cookie += '; path=' + this.$path;
	if (this.$domain) 
		cookie += '; domain=' + this.$domain;
	if (this.$secure) 
		cookie += '; secure=';

	this.$document.cookie = cookie;
}

function _Cookie_load()
{
	var allcookies = this.$document.cookie;
	if (allcookies == "") 
		return false;

	var start = allcookies.indexOf(this.$name + '=');
	if (start == -1) 
		return false;

	start += this.$name.length + 1;
	var end = allcookies.indexOf(';', start);
	if (end == -1) 
		end = allcookies.length;

	var cookieval = allcookies.substring(start, end);

	var a = cookieval.split('&');

	for (var i=0; i < a.length; i++)
		a[i] = a[i].split(':');

	for (var i = 0; i < a.length; i++)
		this[a[i][0]] = unescape(a[i][1]);

	return true;
}

function _Cookie_remove()
{
	var cookie; 
	cookie = this.$name + '=';
	if (this.$path) 
		cookie += '; path=' + this.$path;
	if (this.$domain) 
		cookie += '; domain=' + this.$domain;
	cookie += '; expires=Fri, 02-Jan-1970 00:00:00 GMT';

	this.$document.cookie = cookie;
}

function resetDrive()
{
	var drivemsg;
	var resetdata = new Cookie(document, "cd_drive", 720);

	if (isWindows())
		drivemsg = "Please enter Drive Letter of the drive to browse.\n";
	else
		drivemsg = "Please enter path of directory to browse.\n";

	resetdata.drive = prompt(drivemsg, visitordata.drive);

	if (resetdata.drive != null)
	    resetdata.store();
}

function writeDoc(drive)
{
    var drivesrc;

    if (drive != null && drive != "" & drive != "null" && drive != "n")
	{
	    if (isWindows())
		{
		    drivesrc = "file:///"+drive+"|/ ";
		    document.write('<html>'+
				   '<head>'+
				   '  <title>Browse Files</title>'+
				   '</head>'+
				   '<frameset frameborder=yes scrolling=no framespacing="0" rows="36,*">'+
				   '  <frame name="browseNavBar" src="browse_files_navbar.html" marginheight=0 marginwidth=0>'+
				   '  <frame name="browse" src=' + drivesrc + ' marginheight="1" marginwidth="1">'+
				   '</frameset>'+
				   '</html>');
	    } else 
		{
		    drivesrc = "file:/" + drive;
            document.write('<html>'+
				   '<head>'+
				   '  <title>Browse Files</title>'+
				   '</head>'+
				   '<frameset frameborder=yes scrolling=no framespacing="0" rows="36,*">'+
				   '  <frame name="browseNavBar" src="browse_files_navbar.html" marginheight=0 marginwidth=0>'+
				   '  <frame name="browse" src="' + drivesrc + '" marginheight="1" marginwidth="1">'+
				   '</frameset>'+
				   '</html>');
		}

	} else {
	    document.write('<html>'+
				   '<head>'+
				   '  <title>Browse Files</title>'+
				   '</head>'+
				   '<frameset frameborder=yes scrolling=no framespacing="0" rows="36,*">'+
				   '  <frame name="browseNavBar" src="browse_files_navbar.html" marginheight=0 marginwidth=0>'+
				   '  <frame name="browse" src="browse_files_error.html" marginheight="1" marginwidth="1">'+
				   '</frameset>'+
				   '</html>');
	}
}

new Cookie();
Cookie.prototype.store = _Cookie_store;
Cookie.prototype.load = _Cookie_load;
Cookie.prototype.remove = _Cookie_remove;


var visitordata = new Cookie(document, "cd_drive", 720);
var driveletter;
var drivemsg;

if (isWindows())
    drivemsg = "Please enter Drive Letter of the drive to browse.\n" + "You can change this later by clicking on the Browse Button.";
else
    drivemsg = "Please enter path of directory to browse.\n" + "You can change this later by clicking on the Browse Button.";

if (!visitordata.load() || !visitordata.drive)
	visitordata.drive = prompt(drivemsg, "");

if (isWindows())
{
	// We only need first drive letter, and nothing after that on Windows
	if (visitordata.drive != null)
		visitordata.drive = visitordata.drive.substring(0,1);
}

visitordata.store();
writeDoc(visitordata.drive);
